# Frontend Code

This page explains how to source and display the SELF button on your site's frontend.

## Prerequisites

- The SELF button requires a working backend to point to. If you haven't already created a backend, see [Backend Code](./self-backend.md) before proceeding.

## Add the SELF ID Button to your site

1. Add following script within the `<head>` tags of your HTML file:

    ```html
    <script type="text/javascript" src="https://cdn.yourself.id/btn.js"></script>
    ```

  This loads necessary assets (scripts and styles) to display the sign in widget.

1. Add the following script in the appropriate place in your page's `<body>` to display the `Sign in with your SELF` button. Replace `sample-attestor-domain.com` with the FQDN for your backend (do not include the `endpoint` path):

    ```html
    <script>
      // The URL in function argument is of backend snippet Websocket
      createBtn("wss://sample-attestor-domain.com");

      // Another example:
      // createBtn("ws://localhost:3001");
    </script>
    ```

1. You can add additional logic to handle the Websocket responses by adding a function as second parameter. This is a success callback function which executes when backend authorizes the login attempt:

    ```html
    <script>
      createBtn("wss://sample-attestor-domain.com", (data) => {
        console.log(data);
        // add logic to show data
        // in order to fetch claim data you will need to access data.claimData
        console.log(data.claimData);
        // in order to fetch shared data (data which was added in required for login)
        // for example use following logic to fetch ident shared data
        const response = data?.sharedData;
        if (response && Array.isArray(response)) {
          const data = response.find((item) => item.issuer.name.includes(name));
          console.log(data?.atoms || null);
        } else if (response && response.issuer.name.includes(name)) {
          console.log(response?.atoms || null);
        }
      });
    </script>
    ```

    - In the example above, the function in the second parameter is called after the UI receives a "success" message via websocket. You can access success response data thought this function and use it to show or update UI elements.

    - `data.claimData` is data generated by your backend (as an attester).

    - `data.sharedData[0].atoms` contains the atoms you set as required for login from the SELF Markeplace.
    - `data.sharedData[0].issuer` is an array of objects which contains details of issuers (attestors) which provided the atoms. Each entry should contain two properties, `id` (the DID of attester) and `name`.

1. The following is a sample response from the Websocket after login action. You should note that the actual format of this response should be updated based on your specific needs.

    ```json
    {
        "success": true,
        "token": {
            "token": "random token",
            "challenge": "0.20982239409094183",
            "expiresIn": 2592000,
            "isAnonymous": false,
            "clientId": "b72d6b45-fd10",
            "createdAt": "2023-07-07T06:44:06.299Z",
            "updatedAt": "2023-07-07T06:44:46.705Z",
        },
        "sharedData": [
            {
                "issuer": {
                    "id": "did:mdip:omni-xuh4-5y9r-qp6f-905",
                    "name": "Ident"
                },
                "atoms": {
                    "id": "did:mdip:omni-xcqu-5ykq-qqca-sk8",
                    "schema": "QmfVrnoyVgiMjQFfwbyzJTDDsBiRLjCqVsPzYg6zByZusv",
                    "weight": "470",
                    "driversLicense": "RX145899",
                    "sex": "female",
                    "age": 34,
                    "lastName": "Abshire",
                    "firstName": "Jessica"
                }
            }
        ],
        "claimData": {
            "bloodGroup": "AB-",
            "hemoglobin": "13.4 g/dL",
            "ESR": "9.8 mm/hr",
            "redBloodCell": "6.0 cells/mcL"
        },
        "clientId": "b72d6b45-fd10"
    }
    ```

    **Note:** In this example, we're sending user data from the backend service directly to the frontend as part of the login response. In a production environment, user data would be sent to a secure database shared by the front and back end.

1. In case you are dealing with self connect button. You will have to pass `cliendId` in `createBtn` button as third parameter. Check [this](https://gitlab.com/selfid-public/self-sample-attestor-express/-/blob/updated-self-login/template/index.html#L42) sample code where `clientId` is accessed via localstorage (you can choose different method based on your requirement) to use it later to call `createBtn`. Another simple example of the function can be seen below. <!--Editor's note: This section deals with the Connect Your Self button, which I've yet to see or test. -->

    ```html
    <script>
      createBtn(
        "wss://sample-attestor-domain.com",
        (data) => {
          console.log(data);
        },
        cliendId
      );
    </script>
    ```

    `cliendId` should be returned along with token in the auth API response.

    The script containing the `createBtn` function should be added at the end of HTML documents, to avoid the function executing before the rest of the document is loaded completely. Otherwise you will have to use *EventListners* to execute this function on page load events.

    It is recommended to save data from the response function (2nd parameter) in `localStorage` of a Redux store if the information is vital for UI elements.

1. Add the UI element with id `qrcode`:

    ```html
    <div id="qrcode"></div>
    ```

    This element should be added inside the body of your HTML document. This is where the `Sign in with your SELF` button is shown. If you don't add this element, you wont be able to see the widget.

1. Visit `index.html`:

    ![image](https://docs.yourself.id/files/widget-1.png)

    Click the **Sign in with your SELF** button. It will try to connect to the given WebSocket host and return the data (rendered as a QR code) to begin signing in:

    ![image](https://docs.yourself.id/files/widget-2.png)
